package com.sec.xinhua.gateway.beans;

/**
 * Created by zhangqingxin
 * Date : 16/7/5
 * Time : 10:44
 */

import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

@NoArgsConstructor
@JsonIgnoreProperties(ignoreUnknown=true)
public class ApiParam {
    private long id;
    private long productId;//所属产品Id
    private long apiId;//所属接口ID
    private int paramClassification;
    private String sourceName;//客户端需要填写参数名称
    private int paramType;//类型 String,long int short double float boolean char byte file
    private String destName;//dubbo服务提供方参数名称
    private int wrapperType;//[] list set no
    private String description;//描述
    private String defaultValue;//默认值转换
    private int required;//是否必须
    private int paramOrder;//排列顺序
    private long updateTime;//更新时间
    private long updateUserId;


    private long paramId;
    //对象名称
    private String className;

    public long getApiId() {
        return apiId;
    }

    public void setApiId(long apiId) {
        this.apiId = apiId;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = StringUtils.trim(className);
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = StringUtils.trim(defaultValue);
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = StringUtils.trim(description);
    }

    public String getDestName() {
        return destName;
    }

    public void setDestName(String destName) {
        this.destName = StringUtils.trim(destName);
    }


    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public int getParamClassification() {
        return paramClassification;
    }

    public void setParamClassification(int paramClassification) {
        this.paramClassification = paramClassification;
    }

    public long getParamId() {
        return paramId;
    }

    public void setParamId(long paramId) {
        this.paramId = paramId;
    }

    public int getParamOrder() {
        return paramOrder;
    }

    public void setParamOrder(int paramOrder) {
        this.paramOrder = paramOrder;
    }

    public int getParamType() {
        return paramType;
    }

    public void setParamType(int paramType) {
        this.paramType = paramType;
    }

    public long getProductId() {
        return productId;
    }

    public void setProductId(long productId) {
        this.productId = productId;
    }

    public int getRequired() {
        return required;
    }

    public void setRequired(int required) {
        this.required = required;
    }

    public String getSourceName() {
        return sourceName;
    }

    public void setSourceName(String sourceName) {
        this.sourceName = StringUtils.trim(sourceName);
    }

    public long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(long updateTime) {
        this.updateTime = updateTime;
    }

    public long getUpdateUserId() {
        return updateUserId;
    }

    public void setUpdateUserId(long updateUserId) {
        this.updateUserId = updateUserId;
    }

    public int getWrapperType() {
        return wrapperType;
    }

    public void setWrapperType(int wrapperType) {
        this.wrapperType = wrapperType;
    }

    public String getParamTypeString(){
        return ApiParamType.getByCode(paramType).getClassName();
    }

    public boolean isPlatfromParam(){
        if(sourceName.equals("token")||sourceName.equals("api")
                ||sourceName.equals("apiVersion")||sourceName.equals("appKey")
                ||sourceName.equals("timestamp")||sourceName.equals("sign")
                ||sourceName.equals("osVersion")||sourceName.equals("osType")
                ||sourceName.equals("hwId")||sourceName.equals("appVersion")
                ||sourceName.endsWith("mobileType")||sourceName.endsWith("clientIp")
                ||sourceName.endsWith("requestUrl")){
            return true;
        }
        return false;
    }

    public String getJson(){
        Map<String,Object> map = new HashMap<String,Object>();
        map.put("paramClassification", paramClassification);
        map.put("sourceName", sourceName);
        map.put("paramType", paramType);
        map.put("destName", destName);
        map.put("description", description);
        map.put("required", required);
        map.put("paramOrder", paramOrder);
        map.put("defaultValue", defaultValue);
        map.put("className", this.className);
        String json = JSON.toJSONString(map);
        try {
            return URLEncoder.encode(json, "utf-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return null;
    }
}
