package com.sec.xinhua.gateway.beans;


public enum ApiParamType {
    P_INT(10, "int", "int"),
    P_LONG(11, "long", "long"),
    P_SHORT(12, "short", "short"),
    P_BYTE(13, "byte", "byte"),
    P_CHAR(14, "char", "char"),
    P_FLOAT(15, "float", "float"),
    P_DOUBLE(16, "double", "double"),
    P_BOOLEAN(17, "boolean", "boolean"),
    W_INT(20, "Integer", "java.lang.Integer"),
    W_LONG(21, "Long", "java.lang.Long"),
    W_SHORT(22, "Short", "java.lang.Short"),
    W_BYTE(23, "Byte", "java.lang.Byte"),
    W_CHAR(24, "Character", "java.lang.Character"),
    W_FLOAT(25, "Float", "java.lang.Float"),
    W_DOUBLE(26, "Double", "java.lang.Double"),
    W_BOOLEAN(27, "Boolean", "java.lang.Boolean"),
    BYTE_ARRAY(40, "[byte", "[B"),
    STRING(50, "String", "java.lang.String"),
    OBJECT(60, "Object", "json object"),
    List(60, "List", "java.util.List"),
    MAP(70, "Map", "java.util.Map");

    private int code;
    private String name;
    private String className;

    private ApiParamType(int code, String name, String className) {
        this.code = code;
        this.name = name;
        this.className = className;
    }

    public int getCode() {
        return this.code;
    }

    public String getName() {
        return this.name;
    }

    public String getClassName() {
        return this.className;
    }

    public static ApiParamType getByCode(int code) {
        ApiParamType[] values = values();
        for (ApiParamType v : values) {
            if (v.getCode() == code) {
                return v;
            }
        }
        return P_INT;
    }
}
