package com.sec.xinhua.gateway.beans;

/**
 * 网关配置
 *
 * @author xuzhaopeng
 * @version $Id: ServiceRegistry.java, v 0.1 2015年4月7日 下午4:50:27 Administrator Exp $
 */
public class GatewaySetting {

    /**
     * 环境名称
     */
    private String envName;

    private String name;

    /**
     * dubbo注册中心地址
     */
    private String zkAddress;

    /**
     * 是否记录客户端对Risk的请求
     */
    private boolean logRequest;

    /**
     * 是否记录Risk对客户端的响应结果
     */
    private boolean logResponse;

    /**
     * 是否记录Risk对dubbo的调用请求和结果
     */
    private boolean logInvokeResult;

    /**
     * 网关运行模式
     */
    private String runMode = "online";

    /**
     * 网关返回值按dubbo返回,不添加apiCode和apiMsg
     */
    private String originResult;

    public GatewaySetting() {

    }

    public GatewaySetting(String name, String zkAddress) {
        this.name = name;
        this.zkAddress = zkAddress;
    }

    public GatewaySetting(String name, String zkAddress, boolean logRequest, boolean logResponse) {
        this.name = name;
        this.zkAddress = zkAddress;
        this.logRequest = logRequest;
        this.logResponse = logResponse;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getZkAddress() {
        return zkAddress;
    }

    public void setZkAddress(String zkAddress) {
        this.zkAddress = zkAddress;
    }

    public boolean isLogRequest() {
        return logRequest;
    }

    public void setLogRequest(boolean logRequest) {
        this.logRequest = logRequest;
    }

    public boolean isLogResponse() {
        return logResponse;
    }

    public void setLogResponse(boolean logResponse) {
        this.logResponse = logResponse;
    }

    public boolean isLogInvokeResult() {
        return logInvokeResult;
    }

    public void setLogInvokeResult(boolean logInvokeResult) {
        this.logInvokeResult = logInvokeResult;
    }

    public String getRunMode() {
        return runMode;
    }

    public void setRunMode(String runMode) {
        this.runMode = runMode;
    }

    public String getOriginResult() {
        return originResult;
    }

    public void setOriginResult(String originResult) {
        this.originResult = originResult;
    }

    public String getEnvName() {
        return envName;
    }

    public void setEnvName(String envName) {
        this.envName = envName;
    }

    @Override
    public String toString() {
        return "GatewaySetting{" +
                "envName='" + envName + '\'' +
                ", name='" + name + '\'' +
                ", zkAddress='" + zkAddress + '\'' +
                ", logRequest=" + logRequest +
                ", logResponse=" + logResponse +
                ", logInvokeResult=" + logInvokeResult +
                ", runMode='" + runMode + '\'' +
                ", originResult='" + originResult + '\'' +
                '}';
    }
}
