package com.sec.xinhua.gateway.beans;


import java.io.Serializable;
import java.util.List;

public class SimpleApiParam implements Serializable {


    private String sourceName;  //客户端需要填写参数名称

    private int paramType;   //类型 String,long int short double float boolean char byte file

    private String destName;    //dubbo服务提供方参数名称

    private String defaultValue; //默认值转换

    private int required;    //是否必须

    //对象class名称
    private String className;

    //对象字段列表，无序
    private List<SimpleApiParam> fields;

    public static SimpleApiParam resolve(ApiParam apiParam) {
        SimpleApiParam sap = new SimpleApiParam();

        sap.setSourceName(apiParam.getSourceName());
        sap.setParamType(apiParam.getParamType());
        sap.setDestName(apiParam.getDestName());
        sap.setDefaultValue(apiParam.getDefaultValue());
        sap.setRequired(apiParam.getRequired());

        return sap;
    }

    public String getSourceName() {
        return sourceName;
    }

    public void setSourceName(String sourceName) {
        this.sourceName = sourceName;
    }

    public int getParamType() {
        return paramType;
    }

    public void setParamType(int paramType) {
        this.paramType = paramType;
    }

    public String getDestName() {
        return destName;
    }

    public void setDestName(String destName) {
        this.destName = destName;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public int getRequired() {
        return required;
    }

    public void setRequired(int required) {
        this.required = required;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public List<SimpleApiParam> getFields() {
        return fields;
    }

    public void setFields(List<SimpleApiParam> fields) {
        this.fields = fields;
    }

    @Override
    public String toString() {
        return "SimpleApiParam{" +
                "sourceName='" + sourceName + '\'' +
                ", paramType=" + paramType +
                ", destName='" + destName + '\'' +
                ", defaultValue='" + defaultValue + '\'' +
                ", required=" + required +
                ", className='" + className + '\'' +
                ", fields=" + fields +
                '}';
    }
}
