
package com.sec.xinhua.gateway.config;

import com.sec.xinhua.gateway.beans.SimpleApi;

import java.util.List;

import com.alibaba.fastjson.JSON;
import com.sec.xinhua.gateway.config.local.FileConfigLoader;


/**
 * Api接口的配置Load
 */
public class ApiSettingRepository {

    private static ApiSettingRepository INSTANCE = new ApiSettingRepository();

    private List<SimpleApi> items;

    final protected String configFilePath = getConfigDir() + this.getClass().getSimpleName() + ".config";

    protected ConfigLoader configLoader;

    public ApiSettingRepository() {
        configLoader = new FileConfigLoader(configFilePath);
        this.init();
    }

    public static ApiSettingRepository getInstance() {
        return INSTANCE;
    }

    protected String getConfigDir() {
        return ApiSettingRepository.class.getResource("/").getPath();
    }

    protected Object getItem() {
        return items;
    }

    public List<SimpleApi> getObject() {
        return items;
    }

    public List<SimpleApi> getObject(String key) {

        return null;
    }

    public void init() {
        try {
            String content = (String) configLoader.load();
            items = JSON.parseArray(content, SimpleApi.class);
        } catch (Exception e) {
        }
    }

}
