package com.sec.xinhua.gateway.config;

import com.sec.xinhua.gateway.beans.SimpleApi;
import com.sec.xinhua.gateway.config.remote.ApiRemoteRepository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ConfigRepositoryFactory {

    public static void initGatewaySetting() {
        //初始化基本配置
        initGatewaySettingRepository();
    }

    public static Map<String, SimpleApi> simpleApiMap = new HashMap<String, SimpleApi>();

    public static ApiRemoteRepository getApiRepository() {
        return ApiRemoteRepository.getInstance();
    }

    public static GatewaySettingRepository initGatewaySettingRepository() {
        return GatewaySettingRepository.getInstance();
    }

    public static Map<String, SimpleApi> getAllApi() {
        if (simpleApiMap.size() < 1) {
            refreshMap();
        }
        return simpleApiMap;
    }

    /**
     * 刷新Map
     */
    public static void refreshMap() {
        List<SimpleApi> apiList = ApiSettingRepository.getInstance().getObject();
        if (apiList != null && apiList.size() > 0) {
            for (SimpleApi api : apiList) {
                simpleApiMap.put(api.getApiName() + "_" + api.getApiVersion(), api);
            }
        }
    }
}
