package com.sec.xinhua.gateway.config;

import com.alibaba.fastjson.JSON;
import com.sec.xinhua.gateway.beans.GatewaySetting;
import com.sec.xinhua.gateway.config.local.FileConfigLoader;

/**
 * 网关的全局配置
 */
public class GatewaySettingRepository {

    private static GatewaySettingRepository INSTANCE = new GatewaySettingRepository();

    private GatewaySetting item;

    final protected String configFilePath = getConfigDir() + this.getClass().getSimpleName() + ".config";

    protected ConfigLoader configLoader;

    public static GatewaySettingRepository getInstance() {
        return INSTANCE;
    }

    public GatewaySettingRepository() {
        configLoader = new FileConfigLoader(configFilePath);
        init();
    }

    protected String getConfigDir() {
        return GatewaySettingRepository.class.getResource("/").getPath();
    }

    public GatewaySetting getObject() {
        return item;
    }

    public void init() {
        try {
            String content = (String) configLoader.load();
            item = JSON.parseObject(content, GatewaySetting.class);
        } catch (Exception e) {
        }
    }

    public static void main(String[] args) {
        GatewaySettingRepository.getInstance();
    }


}
