package com.sec.xinhua.gateway.config.remote;


import com.sec.xinhua.gateway.beans.SimpleApi;
import com.sec.xinhua.gateway.config.ConfigRepositoryFactory;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * API本地配置仓库
 *
 * @author zhangqingxin
 * @version $Id: ApiRemoteRepository.java, v 0.1 2016年7月4日 下午5:39:03 Administrator Exp $
 */
public class ApiRemoteRepository {

    private static ApiRemoteRepository INSTANCE = new ApiRemoteRepository();

    private Map<String, SimpleApi> items = new HashMap<String, SimpleApi>();

    public static ApiRemoteRepository getInstance() {
        return INSTANCE;
    }

    public ApiRemoteRepository() {
        this.init();
    }

    public SimpleApi getObject(String key) {
        return ConfigRepositoryFactory.simpleApiMap.get(key);
    }

    public void init() {
        items = ConfigRepositoryFactory.getAllApi();
    }

    public static void main(String[] args) {
        INSTANCE.init();
    }

    public Set<String> keySet() {
        HashSet<String> set = new HashSet<String>();
        set.addAll(items.keySet());
        return set;
    }

}
