package com.sec.xinhua.gateway.parse;

import java.util.HashMap;
import java.util.Map;

public class RequestParam {
    private SysParam sysParam;

    private Map<String, Object> bizParams = new HashMap<String, Object>();

    private String bizStringCache = null;

    public void putBizParam(String key, Object value) {
        bizParams.put(key, value);
    }

    public String getBizParamsChars() {
        if (bizStringCache != null) {
            return bizStringCache;
        }
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, Object> entry : bizParams.entrySet()) {
            sb.append(entry.getKey()).append(":");
            if (entry.getValue() != null && entry.getValue() instanceof byte[]) {
                byte[] tmp = (byte[]) entry.getValue();
                sb.append("byte[").append(tmp.length).append("]");
            } else {
                //保密关键字日志转换
            }
            sb.append(",");
        }

        if (sb.length() > 0) {
            sb.deleteCharAt(sb.length() - 1);
        }
        bizStringCache = sb.toString();
        return bizStringCache;
    }

    public SysParam getSysParam() {
        return sysParam;
    }

    public void setSysParam(SysParam sysParam) {
        this.sysParam = sysParam;
    }

    public Object getParameter(String key) {
        return bizParams.get(key);
    }

    public Object getSysParameter(String key) {
        return sysParam.getParam(key);
    }

    public Map<String, Object> getBizParams() {
        return bizParams;
    }

    public void setBizParams(Map<String, Object> bizParams) {
        this.bizParams = bizParams;
    }

    @Override
    public String toString() {
        return "HttpParam{bizParams=" + bizParams + '}';
    }
}
