package com.sec.xinhua.gateway.utils;

import org.apache.commons.io.FileUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.File;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Created by Administrator on 2017/3/4 0004.
 */
public class IpFileCache extends AbstractLocalCache<String> {
    private static final Log LOCAL_CACHE_LOGGER = LogFactory.getLog("errorLogger");

    private static IpFileCache ipFileCache = null;
    private List<String> ips = new ArrayList<String>();

    private IpFileCache() {
        this.reLoad();
    }

    public static IpFileCache getInstance() {
        if (ipFileCache == null) {
            synchronized (IpFileCache.class) {
                if (ipFileCache == null) {
                    ipFileCache = new IpFileCache();
                }
            }
        }
        return ipFileCache;
    }

    @Override
    protected List<String> reLoad() {
        try {
            String path =IpFileCache.class.getClassLoader().getResource("allow_ip.txt").getPath();
            File ipFile = new File(path);
            ips = FileUtils.readLines(ipFile);
        } catch (Exception e) {
            LOCAL_CACHE_LOGGER.info("[-IpFileCache-] load ip file exception , " + e);
        }
        return ips;
    }

    public List<String> getIps() {
        return ips;
    }

}
