package com.sec.xinhua.gateway.utils;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.text.SimpleDateFormat;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

/**
 * 比较杂的工具类
 *
 */
public class URLHelper {
    private static final Logger logger      = Logger.getLogger(URLHelper.class);
    private static final String TIME_FORMAT = "yyyyMMddHH:mm";

    public static String getIpAddr(HttpServletRequest request) {
        String ip = request.getHeader("x-forwarded-for");
        if (StringUtils.isBlank(ip) || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("Proxy-Client-IP");
        }
        if (StringUtils.isBlank(ip) || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("WL-Proxy-Client-IP");
        }
        if (StringUtils.isBlank(ip) || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getRemoteAddr();
        }

        return fixIp(ip);
    }

    /**
     * x-forwarded-for nginx多层ip处理
     * @param ip
     * @return
     */
    private static String fixIp(String ip) {
        if (StringUtils.isNotBlank(ip) && ip.contains(",")) {
            ip = ip.split(",")[0];
        }
        return ip;
    }

    public static String decode(String param) {
        if (param == null) {
            return null;
        }

        String newStr = null;
        try {
            newStr = URLDecoder.decode(param, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            logger.error("Url decode error,orginal value:" + param, e);
        }
        return newStr;
    }

    public static String getStackTrace(Throwable t) {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);

        try {
            t.printStackTrace(pw);
            return sw.toString();
        } finally {
            pw.close();
        }
    }

    public static String getCurrentTime() {
        return new SimpleDateFormat(TIME_FORMAT).format(System.currentTimeMillis());
    }
    
    public static void main(String[] args) {
        System.out.println(getCurrentTime());
    }
}
