//package com.sec.xinhua.gateway.web;
//
//import com.alibaba.fastjson.JSON;
//import com.google.common.collect.Maps;
//import org.apache.http.HttpEntity;
//import org.apache.http.HttpResponse;
//import org.apache.http.client.methods.HttpPost;
//import org.apache.http.conn.scheme.Scheme;
//import org.apache.http.conn.ssl.SSLSocketFactory;
//import org.apache.http.entity.StringEntity;
//import org.apache.http.entity.mime.MultipartEntity;
//import org.apache.http.entity.mime.content.FileBody;
//import org.apache.http.entity.mime.content.StringBody;
//import org.apache.http.impl.client.DefaultHttpClient;
//import org.apache.http.util.EntityUtils;
//
//import javax.net.ssl.*;
//import java.io.File;
//import java.io.FileInputStream;
//import java.io.UnsupportedEncodingException;
//import java.security.KeyStore;
//import java.security.cert.CertificateException;
//import java.security.cert.X509Certificate;
//import java.util.Map;
//
//public class HttpsClient extends DefaultHttpClient {
//
//    /**
//     * 绕过服务端证书验证
//     *
//     * @throws Exception
//     */
//    public HttpsClient() throws Exception {
//        super();
//        SSLContext ctx = SSLContext.getInstance("TLS");
//        X509TrustManager xetm = new X509TrustManager() {
//            @Override
//            public void checkClientTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {
//
//            }
//
//            @Override
//            public void checkServerTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {
//
//            }
//
//            @Override
//            public X509Certificate[] getAcceptedIssuers() {
//                return new X509Certificate[0];
//            }
//        };
//        ctx.init(null, new TrustManager[]{xetm}, null);
//        SSLSocketFactory ssf = new SSLSocketFactory(ctx, SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
//        this.getConnectionManager().getSchemeRegistry().register(new Scheme("https", 443, ssf));
//    }
//
//    /**
//     * 需要服务端证书验证
//     *
//     * @param password
//     * @param keyStorePath
//     * @param trustStorePath
//     * @throws Exception
//     */
//    public HttpsClient(String password, String keyStorePath, String trustStorePath) throws Exception {
//        super();
//        SSLContext ctx = getSSLContext(password, keyStorePath, trustStorePath);
//        SSLSocketFactory ssf = new SSLSocketFactory(ctx, SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
//        this.getConnectionManager().getSchemeRegistry().register(new Scheme("https", 443, ssf));
//    }
//
//    /**
//     * 获得KeyStore.
//     *
//     * @param keyStorePath 密钥库路径
//     * @param password     密码
//     * @return 密钥库
//     * @throws Exception
//     */
//    public static KeyStore getKeyStore(String password, String keyStorePath)
//            throws Exception {
//        // 实例化密钥库
//        KeyStore ks = KeyStore.getInstance("JKS");
//        // 获得密钥库文件流
//        FileInputStream is = new FileInputStream(keyStorePath);
//        // 加载密钥库
//        ks.load(is, password.toCharArray());
//        // 关闭密钥库文件流
//        is.close();
//        return ks;
//    }
//
//    /**
//     * 获得SSLSocketFactory.
//     *
//     * @param password       密码
//     * @param keyStorePath   密钥库路径
//     * @param trustStorePath 信任库路径
//     * @return SSLSocketFactory
//     * @throws Exception
//     */
//    public static SSLContext getSSLContext(String password,
//                                           String keyStorePath, String trustStorePath) throws Exception {
//        // 实例化密钥库
//        KeyManagerFactory keyManagerFactory = KeyManagerFactory
//                .getInstance(KeyManagerFactory.getDefaultAlgorithm());
//        // 获得密钥库
//        KeyStore keyStore = getKeyStore(password, keyStorePath);
//        // 初始化密钥工厂
//        keyManagerFactory.init(keyStore, password.toCharArray());
//
//        // 实例化信任库
//        TrustManagerFactory trustManagerFactory = TrustManagerFactory
//                .getInstance(TrustManagerFactory.getDefaultAlgorithm());
//        // 获得信任库
//        KeyStore trustStore = getKeyStore(password, trustStorePath);
//        // 初始化信任库
//        trustManagerFactory.init(trustStore);
//        // 实例化SSL上下文
//        SSLContext ctx = SSLContext.getInstance("TLS");
//        // 初始化SSL上下文
//        ctx.init(keyManagerFactory.getKeyManagers(),
//                trustManagerFactory.getTrustManagers(), null);
//        // 获得SSLSocketFactory
//        return ctx;
//    }
//
//
//    /**
//     * 测试方法.
//     *
//     * @param args
//     * @throws Exception
//     */
//    public static void main(String[] args) throws Exception {
//
//        /**
//         * URL,参数,签名构造
//         */
//        String appSecret = "4D145C6FA84E38099E49930D9D5B4B73D0C2317D";
//        String appKey = "190001";
//
//        guideRequest(appSecret, appKey);
//
//        liveFail(appKey, appKey);
//
//        faceVerify(appSecret, appKey);
////        /**
////         * 方式一 : 绕过服务端证书验证
////         */
////        HttpsClient clientNoValidate = new HttpsClient();
////        HttpResponse noValidateResponse = clientNoValidate.execute(httpRequest);
////        System.out.println(EntityUtils.toString(noValidateResponse.getEntity(), "UTF-8"));
//    }
//
//    /**
//     * 引导接口测试
//     *
//     * @param signKey
//     * @param appKey
//     * @throws Exception
//     */
//    private static void guideRequest(String signKey, String appKey) throws Exception {
//        Map<String, Object> params = Maps.newHashMap();
//        params.put("token", "abcd");
//        params.put("bizCode", 123);
//        params.put("sdkVersion", "1.0.0");
//        String signData = SignUtils.getSignData(params);
//        String sign = SignUtils.getSign(signKey, signData);
//        String url = "https://10.94.97.117:8443/risk-gateway/gateway?api=risk.face.guide&apiVersion=1.0.0&appKey=" + appKey + "&sign=" + sign;
//        HttpPost httpRequest = new HttpPost(url);
//        HttpEntity entity = new StringEntity(JSON.toJSONString(params), "UTF-8");
//        httpRequest.setEntity(entity);
//        /**
//         * 方式二 : 需要服务端证书验证 (jdk生成的keystore)
//         */
//        String password = "hzsd.risk";
//        String keyStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//        String trustStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//
//        HttpsClient clientValidate = new HttpsClient(password, keyStorePath, trustStorePath);
//        HttpResponse validateResponse = clientValidate.execute(httpRequest);
//        System.out.println("guideRequest result : " + EntityUtils.toString(validateResponse.getEntity(), "UTF-8"));
//    }
//
//    /**
//     * 活体失败接口测试
//     *
//     * @param signKey
//     * @param appKey
//     * @throws Exception
//     */
//    private static void liveFail(String signKey, String appKey) throws Exception {
//        Map<String, Object> params = Maps.newHashMap();
//        params.put("aliveCheckFailParamJson", "aliveCheckFailParamJson-params");
//        String signData = SignUtils.getSignData(params);
//        String sign = SignUtils.getSign(signKey, signData);
//        String url = "https://localhost:8443/risk-gateway/gateway?api=risk.faceplus.alive&apiVersion=1.0.0&appKey=" + appKey + "&sign=" + sign;
//        HttpPost httpRequest = new HttpPost(url);
//        HttpEntity entity = new StringEntity(JSON.toJSONString(params), "UTF-8");
//        httpRequest.setEntity(entity);
//        /**
//         * 方式二 : 需要服务端证书验证 (jdk生成的keystore)
//         */
//        String password = "hzsd.risk";
//        String keyStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//        String trustStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//
//        HttpsClient clientValidate = new HttpsClient(password, keyStorePath, trustStorePath);
//        HttpResponse validateResponse = clientValidate.execute(httpRequest);
//        System.out.println("liveFail result : " + EntityUtils.toString(validateResponse.getEntity(), "UTF-8"));
//    }
//
//    /**
//     * 人脸验证接口测试
//     *
//     * @param signKey
//     * @param appKey
//     * @throws Exception
//     */
//    private static void faceVerify(String signKey, String appKey) throws Exception {
//        Map<String, Object> params = Maps.newHashMap();
//        params.put("token", "abcd");
//        params.put("delta", "efgh");
//        String signData = SignUtils.getSignData(params);
//        String sign = SignUtils.getSign(signKey, signData);
//        String url = "https://10.94.97.117:8443/risk-gateway/gateway?api=risk.faceplus.compare&apiVersion=1.0.0&appKey=" + appKey + "&sign=" + sign;
//        HttpPost httpRequest = new HttpPost(url);
//
//
//        MultipartEntity mutiEntity = new MultipartEntity();
//        File bestPic = new File("/Users/zhangqingxin/test.jpg");
//        File actionPic1 = new File("/Users/zhangqingxin/test2.png");
//        File actionPic2 = new File("/Users/zhangqingxin/test2.png");
//        File actionPic3 = new File("/Users/zhangqingxin/test2.png");
//        File actionPic4 = new File("/Users/zhangqingxin/test2.png");
//        mutiEntity.addPart("token", new StringBody("abcd"));
//        mutiEntity.addPart("delta", new StringBody("efgh"));
//        mutiEntity.addPart("bestPic", new FileBody(bestPic));
//        mutiEntity.addPart("actionPic1", new FileBody(actionPic1));
//        mutiEntity.addPart("actionPic2", new FileBody(actionPic2));
//        mutiEntity.addPart("actionPic3", new FileBody(actionPic3));
//        mutiEntity.addPart("actionPic4", new FileBody(actionPic4));
//        httpRequest.setEntity(mutiEntity);
//
//        /**
//         * 方式二 : 需要服务端证书验证 (jdk生成的keystore)
//         */
//        String password = "hzsd.risk";
//        String keyStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//        String trustStorePath = "/usr/local/apache-tomcat-9.0.0/tomcat.keystore";
//
//        HttpsClient clientValidate = new HttpsClient(password, keyStorePath, trustStorePath);
//        HttpResponse validateResponse = clientValidate.execute(httpRequest);
//        System.out.println("faceVerify result : " + EntityUtils.toString(validateResponse.getEntity(), "UTF-8"));
//    }
//
//
//}