package com.sec.xinhua.gateway.web;

import java.io.File;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * Created by zhangqingxin
 * Date : 16/5/11
 * Time : 14:25
 */
public class SignUtils {
    public static String getSignData(Map<String, Object> params) {
        StringBuffer content = new StringBuffer();
        // 按照key做排序
        List<String> keys = new ArrayList<String>(params.keySet());
        Collections.sort(keys);
        for (int i = 0; i < keys.size(); i++) {
            String key = keys.get(i);
            Object value = params.get(key);
            if (value instanceof byte[] || value instanceof File) {
                continue;
            }
            if (value == null) {
                continue;
            }
            content.append((i == 0 || content.length() == 0 ? "" : "&") + key + value.toString());

        }
        return content.toString();
    }

    public static String getSign(String signKey, String content) {
        String result = content + "&" + signKey;
        try {
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] byteArray = result.getBytes("UTF-8");
            byte[] md5Bytes = md5.digest(byteArray);
            StringBuffer hexValue = new StringBuffer();
            for (int i = 0; i < md5Bytes.length; i++) {
                int val = ((int) md5Bytes[i]) & 0xff;
                if (val < 16) {
                    hexValue.append("0");
                }
                hexValue.append(Integer.toHexString(val));
            }
            return hexValue.toString().toUpperCase();
        } catch (Exception e) {
            return "";
        }
    }
}
